<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCashDrawer ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCashDrawer
 * @subpackage Arrays
 */
class ArrayOfCashDrawer extends AbstractStructArrayBase
{
    /**
     * The CashDrawer
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CashDrawer[]
     */
    public $CashDrawer;
    /**
     * Constructor method for ArrayOfCashDrawer
     * @uses ArrayOfCashDrawer::setCashDrawer()
     * @param \StructType\CashDrawer[] $cashDrawer
     */
    public function __construct(array $cashDrawer = array())
    {
        $this
            ->setCashDrawer($cashDrawer);
    }
    /**
     * Get CashDrawer value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CashDrawer[]|null
     */
    public function getCashDrawer()
    {
        return isset($this->CashDrawer) ? $this->CashDrawer : null;
    }
    /**
     * Set CashDrawer value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CashDrawer[] $cashDrawer
     * @return \ArrayType\ArrayOfCashDrawer
     */
    public function setCashDrawer(array $cashDrawer = array())
    {
        foreach ($cashDrawer as $arrayOfCashDrawerCashDrawerItem) {
            // validation for constraint: itemType
            if (!$arrayOfCashDrawerCashDrawerItem instanceof \StructType\CashDrawer) {
                throw new \InvalidArgumentException(sprintf('The CashDrawer property can only contain items of \StructType\CashDrawer, "%s" given', is_object($arrayOfCashDrawerCashDrawerItem) ? get_class($arrayOfCashDrawerCashDrawerItem) : gettype($arrayOfCashDrawerCashDrawerItem)), __LINE__);
            }
        }
        if (is_null($cashDrawer) || (is_array($cashDrawer) && empty($cashDrawer))) {
            unset($this->CashDrawer);
        } else {
            $this->CashDrawer = $cashDrawer;
        }
        return $this;
    }
    /**
     * Add item to CashDrawer value
     * @throws \InvalidArgumentException
     * @param \StructType\CashDrawer $item
     * @return \ArrayType\ArrayOfCashDrawer
     */
    public function addToCashDrawer(\StructType\CashDrawer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CashDrawer) {
            throw new \InvalidArgumentException(sprintf('The CashDrawer property can only contain items of \StructType\CashDrawer, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CashDrawer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CashDrawer|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CashDrawer|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CashDrawer|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CashDrawer|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CashDrawer|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CashDrawer
     */
    public function getAttributeName()
    {
        return 'CashDrawer';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCashDrawer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
