<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportDiscountAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportDiscountAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportDiscountAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportDiscountAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportDiscountAccount[]
     */
    public $GLExportDiscountAccount;
    /**
     * Constructor method for ArrayOfGLExportDiscountAccount
     * @uses ArrayOfGLExportDiscountAccount::setGLExportDiscountAccount()
     * @param \StructType\GLExportDiscountAccount[] $gLExportDiscountAccount
     */
    public function __construct(array $gLExportDiscountAccount = array())
    {
        $this
            ->setGLExportDiscountAccount($gLExportDiscountAccount);
    }
    /**
     * Get GLExportDiscountAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportDiscountAccount[]|null
     */
    public function getGLExportDiscountAccount()
    {
        return isset($this->GLExportDiscountAccount) ? $this->GLExportDiscountAccount : null;
    }
    /**
     * Set GLExportDiscountAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportDiscountAccount[] $gLExportDiscountAccount
     * @return \ArrayType\ArrayOfGLExportDiscountAccount
     */
    public function setGLExportDiscountAccount(array $gLExportDiscountAccount = array())
    {
        foreach ($gLExportDiscountAccount as $arrayOfGLExportDiscountAccountGLExportDiscountAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportDiscountAccountGLExportDiscountAccountItem instanceof \StructType\GLExportDiscountAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportDiscountAccount property can only contain items of \StructType\GLExportDiscountAccount, "%s" given', is_object($arrayOfGLExportDiscountAccountGLExportDiscountAccountItem) ? get_class($arrayOfGLExportDiscountAccountGLExportDiscountAccountItem) : gettype($arrayOfGLExportDiscountAccountGLExportDiscountAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportDiscountAccount) || (is_array($gLExportDiscountAccount) && empty($gLExportDiscountAccount))) {
            unset($this->GLExportDiscountAccount);
        } else {
            $this->GLExportDiscountAccount = $gLExportDiscountAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportDiscountAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportDiscountAccount $item
     * @return \ArrayType\ArrayOfGLExportDiscountAccount
     */
    public function addToGLExportDiscountAccount(\StructType\GLExportDiscountAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportDiscountAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportDiscountAccount property can only contain items of \StructType\GLExportDiscountAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportDiscountAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportDiscountAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportDiscountAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportDiscountAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportDiscountAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportDiscountAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportDiscountAccount
     */
    public function getAttributeName()
    {
        return 'GLExportDiscountAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportDiscountAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
