<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportPettyAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportPettyAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportPettyAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportPettyAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportPettyAccount[]
     */
    public $GLExportPettyAccount;
    /**
     * Constructor method for ArrayOfGLExportPettyAccount
     * @uses ArrayOfGLExportPettyAccount::setGLExportPettyAccount()
     * @param \StructType\GLExportPettyAccount[] $gLExportPettyAccount
     */
    public function __construct(array $gLExportPettyAccount = array())
    {
        $this
            ->setGLExportPettyAccount($gLExportPettyAccount);
    }
    /**
     * Get GLExportPettyAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportPettyAccount[]|null
     */
    public function getGLExportPettyAccount()
    {
        return isset($this->GLExportPettyAccount) ? $this->GLExportPettyAccount : null;
    }
    /**
     * Set GLExportPettyAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportPettyAccount[] $gLExportPettyAccount
     * @return \ArrayType\ArrayOfGLExportPettyAccount
     */
    public function setGLExportPettyAccount(array $gLExportPettyAccount = array())
    {
        foreach ($gLExportPettyAccount as $arrayOfGLExportPettyAccountGLExportPettyAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportPettyAccountGLExportPettyAccountItem instanceof \StructType\GLExportPettyAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportPettyAccount property can only contain items of \StructType\GLExportPettyAccount, "%s" given', is_object($arrayOfGLExportPettyAccountGLExportPettyAccountItem) ? get_class($arrayOfGLExportPettyAccountGLExportPettyAccountItem) : gettype($arrayOfGLExportPettyAccountGLExportPettyAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportPettyAccount) || (is_array($gLExportPettyAccount) && empty($gLExportPettyAccount))) {
            unset($this->GLExportPettyAccount);
        } else {
            $this->GLExportPettyAccount = $gLExportPettyAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportPettyAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportPettyAccount $item
     * @return \ArrayType\ArrayOfGLExportPettyAccount
     */
    public function addToGLExportPettyAccount(\StructType\GLExportPettyAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportPettyAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportPettyAccount property can only contain items of \StructType\GLExportPettyAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportPettyAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportPettyAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportPettyAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportPettyAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportPettyAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportPettyAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportPettyAccount
     */
    public function getAttributeName()
    {
        return 'GLExportPettyAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportPettyAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
