<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportPromotionAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportPromotionAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportPromotionAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportPromotionAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportPromotionAccount[]
     */
    public $GLExportPromotionAccount;
    /**
     * Constructor method for ArrayOfGLExportPromotionAccount
     * @uses ArrayOfGLExportPromotionAccount::setGLExportPromotionAccount()
     * @param \StructType\GLExportPromotionAccount[] $gLExportPromotionAccount
     */
    public function __construct(array $gLExportPromotionAccount = array())
    {
        $this
            ->setGLExportPromotionAccount($gLExportPromotionAccount);
    }
    /**
     * Get GLExportPromotionAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportPromotionAccount[]|null
     */
    public function getGLExportPromotionAccount()
    {
        return isset($this->GLExportPromotionAccount) ? $this->GLExportPromotionAccount : null;
    }
    /**
     * Set GLExportPromotionAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportPromotionAccount[] $gLExportPromotionAccount
     * @return \ArrayType\ArrayOfGLExportPromotionAccount
     */
    public function setGLExportPromotionAccount(array $gLExportPromotionAccount = array())
    {
        foreach ($gLExportPromotionAccount as $arrayOfGLExportPromotionAccountGLExportPromotionAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportPromotionAccountGLExportPromotionAccountItem instanceof \StructType\GLExportPromotionAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportPromotionAccount property can only contain items of \StructType\GLExportPromotionAccount, "%s" given', is_object($arrayOfGLExportPromotionAccountGLExportPromotionAccountItem) ? get_class($arrayOfGLExportPromotionAccountGLExportPromotionAccountItem) : gettype($arrayOfGLExportPromotionAccountGLExportPromotionAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportPromotionAccount) || (is_array($gLExportPromotionAccount) && empty($gLExportPromotionAccount))) {
            unset($this->GLExportPromotionAccount);
        } else {
            $this->GLExportPromotionAccount = $gLExportPromotionAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportPromotionAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportPromotionAccount $item
     * @return \ArrayType\ArrayOfGLExportPromotionAccount
     */
    public function addToGLExportPromotionAccount(\StructType\GLExportPromotionAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportPromotionAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportPromotionAccount property can only contain items of \StructType\GLExportPromotionAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportPromotionAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportPromotionAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportPromotionAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportPromotionAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportPromotionAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportPromotionAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportPromotionAccount
     */
    public function getAttributeName()
    {
        return 'GLExportPromotionAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportPromotionAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
