<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportRevenueCenterAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportRevenueCenterAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportRevenueCenterAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportRevenueCenterAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportRevenueCenterAccount[]
     */
    public $GLExportRevenueCenterAccount;
    /**
     * Constructor method for ArrayOfGLExportRevenueCenterAccount
     * @uses ArrayOfGLExportRevenueCenterAccount::setGLExportRevenueCenterAccount()
     * @param \StructType\GLExportRevenueCenterAccount[] $gLExportRevenueCenterAccount
     */
    public function __construct(array $gLExportRevenueCenterAccount = array())
    {
        $this
            ->setGLExportRevenueCenterAccount($gLExportRevenueCenterAccount);
    }
    /**
     * Get GLExportRevenueCenterAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportRevenueCenterAccount[]|null
     */
    public function getGLExportRevenueCenterAccount()
    {
        return isset($this->GLExportRevenueCenterAccount) ? $this->GLExportRevenueCenterAccount : null;
    }
    /**
     * Set GLExportRevenueCenterAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportRevenueCenterAccount[] $gLExportRevenueCenterAccount
     * @return \ArrayType\ArrayOfGLExportRevenueCenterAccount
     */
    public function setGLExportRevenueCenterAccount(array $gLExportRevenueCenterAccount = array())
    {
        foreach ($gLExportRevenueCenterAccount as $arrayOfGLExportRevenueCenterAccountGLExportRevenueCenterAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportRevenueCenterAccountGLExportRevenueCenterAccountItem instanceof \StructType\GLExportRevenueCenterAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportRevenueCenterAccount property can only contain items of \StructType\GLExportRevenueCenterAccount, "%s" given', is_object($arrayOfGLExportRevenueCenterAccountGLExportRevenueCenterAccountItem) ? get_class($arrayOfGLExportRevenueCenterAccountGLExportRevenueCenterAccountItem) : gettype($arrayOfGLExportRevenueCenterAccountGLExportRevenueCenterAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportRevenueCenterAccount) || (is_array($gLExportRevenueCenterAccount) && empty($gLExportRevenueCenterAccount))) {
            unset($this->GLExportRevenueCenterAccount);
        } else {
            $this->GLExportRevenueCenterAccount = $gLExportRevenueCenterAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportRevenueCenterAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportRevenueCenterAccount $item
     * @return \ArrayType\ArrayOfGLExportRevenueCenterAccount
     */
    public function addToGLExportRevenueCenterAccount(\StructType\GLExportRevenueCenterAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportRevenueCenterAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportRevenueCenterAccount property can only contain items of \StructType\GLExportRevenueCenterAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportRevenueCenterAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportRevenueCenterAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportRevenueCenterAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportRevenueCenterAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportRevenueCenterAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportRevenueCenterAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportRevenueCenterAccount
     */
    public function getAttributeName()
    {
        return 'GLExportRevenueCenterAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportRevenueCenterAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
