<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportSurchargeAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportSurchargeAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportSurchargeAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportSurchargeAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportSurchargeAccount[]
     */
    public $GLExportSurchargeAccount;
    /**
     * Constructor method for ArrayOfGLExportSurchargeAccount
     * @uses ArrayOfGLExportSurchargeAccount::setGLExportSurchargeAccount()
     * @param \StructType\GLExportSurchargeAccount[] $gLExportSurchargeAccount
     */
    public function __construct(array $gLExportSurchargeAccount = array())
    {
        $this
            ->setGLExportSurchargeAccount($gLExportSurchargeAccount);
    }
    /**
     * Get GLExportSurchargeAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportSurchargeAccount[]|null
     */
    public function getGLExportSurchargeAccount()
    {
        return isset($this->GLExportSurchargeAccount) ? $this->GLExportSurchargeAccount : null;
    }
    /**
     * Set GLExportSurchargeAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportSurchargeAccount[] $gLExportSurchargeAccount
     * @return \ArrayType\ArrayOfGLExportSurchargeAccount
     */
    public function setGLExportSurchargeAccount(array $gLExportSurchargeAccount = array())
    {
        foreach ($gLExportSurchargeAccount as $arrayOfGLExportSurchargeAccountGLExportSurchargeAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportSurchargeAccountGLExportSurchargeAccountItem instanceof \StructType\GLExportSurchargeAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportSurchargeAccount property can only contain items of \StructType\GLExportSurchargeAccount, "%s" given', is_object($arrayOfGLExportSurchargeAccountGLExportSurchargeAccountItem) ? get_class($arrayOfGLExportSurchargeAccountGLExportSurchargeAccountItem) : gettype($arrayOfGLExportSurchargeAccountGLExportSurchargeAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportSurchargeAccount) || (is_array($gLExportSurchargeAccount) && empty($gLExportSurchargeAccount))) {
            unset($this->GLExportSurchargeAccount);
        } else {
            $this->GLExportSurchargeAccount = $gLExportSurchargeAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportSurchargeAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportSurchargeAccount $item
     * @return \ArrayType\ArrayOfGLExportSurchargeAccount
     */
    public function addToGLExportSurchargeAccount(\StructType\GLExportSurchargeAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportSurchargeAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportSurchargeAccount property can only contain items of \StructType\GLExportSurchargeAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportSurchargeAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportSurchargeAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportSurchargeAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportSurchargeAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportSurchargeAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportSurchargeAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportSurchargeAccount
     */
    public function getAttributeName()
    {
        return 'GLExportSurchargeAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportSurchargeAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
