<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportTaxAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportTaxAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportTaxAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportTaxAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportTaxAccount[]
     */
    public $GLExportTaxAccount;
    /**
     * Constructor method for ArrayOfGLExportTaxAccount
     * @uses ArrayOfGLExportTaxAccount::setGLExportTaxAccount()
     * @param \StructType\GLExportTaxAccount[] $gLExportTaxAccount
     */
    public function __construct(array $gLExportTaxAccount = array())
    {
        $this
            ->setGLExportTaxAccount($gLExportTaxAccount);
    }
    /**
     * Get GLExportTaxAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportTaxAccount[]|null
     */
    public function getGLExportTaxAccount()
    {
        return isset($this->GLExportTaxAccount) ? $this->GLExportTaxAccount : null;
    }
    /**
     * Set GLExportTaxAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportTaxAccount[] $gLExportTaxAccount
     * @return \ArrayType\ArrayOfGLExportTaxAccount
     */
    public function setGLExportTaxAccount(array $gLExportTaxAccount = array())
    {
        foreach ($gLExportTaxAccount as $arrayOfGLExportTaxAccountGLExportTaxAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportTaxAccountGLExportTaxAccountItem instanceof \StructType\GLExportTaxAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportTaxAccount property can only contain items of \StructType\GLExportTaxAccount, "%s" given', is_object($arrayOfGLExportTaxAccountGLExportTaxAccountItem) ? get_class($arrayOfGLExportTaxAccountGLExportTaxAccountItem) : gettype($arrayOfGLExportTaxAccountGLExportTaxAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportTaxAccount) || (is_array($gLExportTaxAccount) && empty($gLExportTaxAccount))) {
            unset($this->GLExportTaxAccount);
        } else {
            $this->GLExportTaxAccount = $gLExportTaxAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportTaxAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportTaxAccount $item
     * @return \ArrayType\ArrayOfGLExportTaxAccount
     */
    public function addToGLExportTaxAccount(\StructType\GLExportTaxAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportTaxAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportTaxAccount property can only contain items of \StructType\GLExportTaxAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportTaxAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportTaxAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportTaxAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportTaxAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportTaxAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportTaxAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportTaxAccount
     */
    public function getAttributeName()
    {
        return 'GLExportTaxAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportTaxAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
