<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGLExportTenderAccount ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGLExportTenderAccount
 * @subpackage Arrays
 */
class ArrayOfGLExportTenderAccount extends AbstractStructArrayBase
{
    /**
     * The GLExportTenderAccount
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GLExportTenderAccount[]
     */
    public $GLExportTenderAccount;
    /**
     * Constructor method for ArrayOfGLExportTenderAccount
     * @uses ArrayOfGLExportTenderAccount::setGLExportTenderAccount()
     * @param \StructType\GLExportTenderAccount[] $gLExportTenderAccount
     */
    public function __construct(array $gLExportTenderAccount = array())
    {
        $this
            ->setGLExportTenderAccount($gLExportTenderAccount);
    }
    /**
     * Get GLExportTenderAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GLExportTenderAccount[]|null
     */
    public function getGLExportTenderAccount()
    {
        return isset($this->GLExportTenderAccount) ? $this->GLExportTenderAccount : null;
    }
    /**
     * Set GLExportTenderAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportTenderAccount[] $gLExportTenderAccount
     * @return \ArrayType\ArrayOfGLExportTenderAccount
     */
    public function setGLExportTenderAccount(array $gLExportTenderAccount = array())
    {
        foreach ($gLExportTenderAccount as $arrayOfGLExportTenderAccountGLExportTenderAccountItem) {
            // validation for constraint: itemType
            if (!$arrayOfGLExportTenderAccountGLExportTenderAccountItem instanceof \StructType\GLExportTenderAccount) {
                throw new \InvalidArgumentException(sprintf('The GLExportTenderAccount property can only contain items of \StructType\GLExportTenderAccount, "%s" given', is_object($arrayOfGLExportTenderAccountGLExportTenderAccountItem) ? get_class($arrayOfGLExportTenderAccountGLExportTenderAccountItem) : gettype($arrayOfGLExportTenderAccountGLExportTenderAccountItem)), __LINE__);
            }
        }
        if (is_null($gLExportTenderAccount) || (is_array($gLExportTenderAccount) && empty($gLExportTenderAccount))) {
            unset($this->GLExportTenderAccount);
        } else {
            $this->GLExportTenderAccount = $gLExportTenderAccount;
        }
        return $this;
    }
    /**
     * Add item to GLExportTenderAccount value
     * @throws \InvalidArgumentException
     * @param \StructType\GLExportTenderAccount $item
     * @return \ArrayType\ArrayOfGLExportTenderAccount
     */
    public function addToGLExportTenderAccount(\StructType\GLExportTenderAccount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GLExportTenderAccount) {
            throw new \InvalidArgumentException(sprintf('The GLExportTenderAccount property can only contain items of \StructType\GLExportTenderAccount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->GLExportTenderAccount[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GLExportTenderAccount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GLExportTenderAccount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GLExportTenderAccount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GLExportTenderAccount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GLExportTenderAccount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GLExportTenderAccount
     */
    public function getAttributeName()
    {
        return 'GLExportTenderAccount';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfGLExportTenderAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
