<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItemIncludedModifier ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfItemIncludedModifier
 * @subpackage Arrays
 */
class ArrayOfItemIncludedModifier extends AbstractStructArrayBase
{
    /**
     * The ItemIncludedModifier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItemIncludedModifier[]
     */
    public $ItemIncludedModifier;
    /**
     * Constructor method for ArrayOfItemIncludedModifier
     * @uses ArrayOfItemIncludedModifier::setItemIncludedModifier()
     * @param \StructType\ItemIncludedModifier[] $itemIncludedModifier
     */
    public function __construct(array $itemIncludedModifier = array())
    {
        $this
            ->setItemIncludedModifier($itemIncludedModifier);
    }
    /**
     * Get ItemIncludedModifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItemIncludedModifier[]|null
     */
    public function getItemIncludedModifier()
    {
        return isset($this->ItemIncludedModifier) ? $this->ItemIncludedModifier : null;
    }
    /**
     * Set ItemIncludedModifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItemIncludedModifier[] $itemIncludedModifier
     * @return \ArrayType\ArrayOfItemIncludedModifier
     */
    public function setItemIncludedModifier(array $itemIncludedModifier = array())
    {
        foreach ($itemIncludedModifier as $arrayOfItemIncludedModifierItemIncludedModifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfItemIncludedModifierItemIncludedModifierItem instanceof \StructType\ItemIncludedModifier) {
                throw new \InvalidArgumentException(sprintf('The ItemIncludedModifier property can only contain items of \StructType\ItemIncludedModifier, "%s" given', is_object($arrayOfItemIncludedModifierItemIncludedModifierItem) ? get_class($arrayOfItemIncludedModifierItemIncludedModifierItem) : gettype($arrayOfItemIncludedModifierItemIncludedModifierItem)), __LINE__);
            }
        }
        if (is_null($itemIncludedModifier) || (is_array($itemIncludedModifier) && empty($itemIncludedModifier))) {
            unset($this->ItemIncludedModifier);
        } else {
            $this->ItemIncludedModifier = $itemIncludedModifier;
        }
        return $this;
    }
    /**
     * Add item to ItemIncludedModifier value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemIncludedModifier $item
     * @return \ArrayType\ArrayOfItemIncludedModifier
     */
    public function addToItemIncludedModifier(\StructType\ItemIncludedModifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItemIncludedModifier) {
            throw new \InvalidArgumentException(sprintf('The ItemIncludedModifier property can only contain items of \StructType\ItemIncludedModifier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ItemIncludedModifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItemIncludedModifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItemIncludedModifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItemIncludedModifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItemIncludedModifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItemIncludedModifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItemIncludedModifier
     */
    public function getAttributeName()
    {
        return 'ItemIncludedModifier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfItemIncludedModifier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
