<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLoyaltyReward ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLoyaltyReward
 * @subpackage Arrays
 */
class ArrayOfLoyaltyReward extends AbstractStructArrayBase
{
    /**
     * The LoyaltyReward
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LoyaltyReward[]
     */
    public $LoyaltyReward;
    /**
     * Constructor method for ArrayOfLoyaltyReward
     * @uses ArrayOfLoyaltyReward::setLoyaltyReward()
     * @param \StructType\LoyaltyReward[] $loyaltyReward
     */
    public function __construct(array $loyaltyReward = array())
    {
        $this
            ->setLoyaltyReward($loyaltyReward);
    }
    /**
     * Get LoyaltyReward value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LoyaltyReward[]|null
     */
    public function getLoyaltyReward()
    {
        return isset($this->LoyaltyReward) ? $this->LoyaltyReward : null;
    }
    /**
     * Set LoyaltyReward value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LoyaltyReward[] $loyaltyReward
     * @return \ArrayType\ArrayOfLoyaltyReward
     */
    public function setLoyaltyReward(array $loyaltyReward = array())
    {
        foreach ($loyaltyReward as $arrayOfLoyaltyRewardLoyaltyRewardItem) {
            // validation for constraint: itemType
            if (!$arrayOfLoyaltyRewardLoyaltyRewardItem instanceof \StructType\LoyaltyReward) {
                throw new \InvalidArgumentException(sprintf('The LoyaltyReward property can only contain items of \StructType\LoyaltyReward, "%s" given', is_object($arrayOfLoyaltyRewardLoyaltyRewardItem) ? get_class($arrayOfLoyaltyRewardLoyaltyRewardItem) : gettype($arrayOfLoyaltyRewardLoyaltyRewardItem)), __LINE__);
            }
        }
        if (is_null($loyaltyReward) || (is_array($loyaltyReward) && empty($loyaltyReward))) {
            unset($this->LoyaltyReward);
        } else {
            $this->LoyaltyReward = $loyaltyReward;
        }
        return $this;
    }
    /**
     * Add item to LoyaltyReward value
     * @throws \InvalidArgumentException
     * @param \StructType\LoyaltyReward $item
     * @return \ArrayType\ArrayOfLoyaltyReward
     */
    public function addToLoyaltyReward(\StructType\LoyaltyReward $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LoyaltyReward) {
            throw new \InvalidArgumentException(sprintf('The LoyaltyReward property can only contain items of \StructType\LoyaltyReward, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LoyaltyReward[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LoyaltyReward|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LoyaltyReward|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LoyaltyReward|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LoyaltyReward|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LoyaltyReward|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LoyaltyReward
     */
    public function getAttributeName()
    {
        return 'LoyaltyReward';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLoyaltyReward
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
