<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfModifierCode ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfModifierCode
 * @subpackage Arrays
 */
class ArrayOfModifierCode extends AbstractStructArrayBase
{
    /**
     * The ModifierCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ModifierCode[]
     */
    public $ModifierCode;
    /**
     * Constructor method for ArrayOfModifierCode
     * @uses ArrayOfModifierCode::setModifierCode()
     * @param \StructType\ModifierCode[] $modifierCode
     */
    public function __construct(array $modifierCode = array())
    {
        $this
            ->setModifierCode($modifierCode);
    }
    /**
     * Get ModifierCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ModifierCode[]|null
     */
    public function getModifierCode()
    {
        return isset($this->ModifierCode) ? $this->ModifierCode : null;
    }
    /**
     * Set ModifierCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ModifierCode[] $modifierCode
     * @return \ArrayType\ArrayOfModifierCode
     */
    public function setModifierCode(array $modifierCode = array())
    {
        foreach ($modifierCode as $arrayOfModifierCodeModifierCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfModifierCodeModifierCodeItem instanceof \StructType\ModifierCode) {
                throw new \InvalidArgumentException(sprintf('The ModifierCode property can only contain items of \StructType\ModifierCode, "%s" given', is_object($arrayOfModifierCodeModifierCodeItem) ? get_class($arrayOfModifierCodeModifierCodeItem) : gettype($arrayOfModifierCodeModifierCodeItem)), __LINE__);
            }
        }
        if (is_null($modifierCode) || (is_array($modifierCode) && empty($modifierCode))) {
            unset($this->ModifierCode);
        } else {
            $this->ModifierCode = $modifierCode;
        }
        return $this;
    }
    /**
     * Add item to ModifierCode value
     * @throws \InvalidArgumentException
     * @param \StructType\ModifierCode $item
     * @return \ArrayType\ArrayOfModifierCode
     */
    public function addToModifierCode(\StructType\ModifierCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModifierCode) {
            throw new \InvalidArgumentException(sprintf('The ModifierCode property can only contain items of \StructType\ModifierCode, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ModifierCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ModifierCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ModifierCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ModifierCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ModifierCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ModifierCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ModifierCode
     */
    public function getAttributeName()
    {
        return 'ModifierCode';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfModifierCode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
