<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfModifierGroupItem ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfModifierGroupItem
 * @subpackage Arrays
 */
class ArrayOfModifierGroupItem extends AbstractStructArrayBase
{
    /**
     * The ModifierGroupItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ModifierGroupItem[]
     */
    public $ModifierGroupItem;
    /**
     * Constructor method for ArrayOfModifierGroupItem
     * @uses ArrayOfModifierGroupItem::setModifierGroupItem()
     * @param \StructType\ModifierGroupItem[] $modifierGroupItem
     */
    public function __construct(array $modifierGroupItem = array())
    {
        $this
            ->setModifierGroupItem($modifierGroupItem);
    }
    /**
     * Get ModifierGroupItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ModifierGroupItem[]|null
     */
    public function getModifierGroupItem()
    {
        return isset($this->ModifierGroupItem) ? $this->ModifierGroupItem : null;
    }
    /**
     * Set ModifierGroupItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ModifierGroupItem[] $modifierGroupItem
     * @return \ArrayType\ArrayOfModifierGroupItem
     */
    public function setModifierGroupItem(array $modifierGroupItem = array())
    {
        foreach ($modifierGroupItem as $arrayOfModifierGroupItemModifierGroupItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfModifierGroupItemModifierGroupItemItem instanceof \StructType\ModifierGroupItem) {
                throw new \InvalidArgumentException(sprintf('The ModifierGroupItem property can only contain items of \StructType\ModifierGroupItem, "%s" given', is_object($arrayOfModifierGroupItemModifierGroupItemItem) ? get_class($arrayOfModifierGroupItemModifierGroupItemItem) : gettype($arrayOfModifierGroupItemModifierGroupItemItem)), __LINE__);
            }
        }
        if (is_null($modifierGroupItem) || (is_array($modifierGroupItem) && empty($modifierGroupItem))) {
            unset($this->ModifierGroupItem);
        } else {
            $this->ModifierGroupItem = $modifierGroupItem;
        }
        return $this;
    }
    /**
     * Add item to ModifierGroupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ModifierGroupItem $item
     * @return \ArrayType\ArrayOfModifierGroupItem
     */
    public function addToModifierGroupItem(\StructType\ModifierGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModifierGroupItem) {
            throw new \InvalidArgumentException(sprintf('The ModifierGroupItem property can only contain items of \StructType\ModifierGroupItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ModifierGroupItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ModifierGroupItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ModifierGroupItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ModifierGroupItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ModifierGroupItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ModifierGroupItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ModifierGroupItem
     */
    public function getAttributeName()
    {
        return 'ModifierGroupItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfModifierGroupItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
