<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRevenueCenter ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRevenueCenter
 * @subpackage Arrays
 */
class ArrayOfRevenueCenter extends AbstractStructArrayBase
{
    /**
     * The RevenueCenter
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RevenueCenter[]
     */
    public $RevenueCenter;
    /**
     * Constructor method for ArrayOfRevenueCenter
     * @uses ArrayOfRevenueCenter::setRevenueCenter()
     * @param \StructType\RevenueCenter[] $revenueCenter
     */
    public function __construct(array $revenueCenter = array())
    {
        $this
            ->setRevenueCenter($revenueCenter);
    }
    /**
     * Get RevenueCenter value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RevenueCenter[]|null
     */
    public function getRevenueCenter()
    {
        return isset($this->RevenueCenter) ? $this->RevenueCenter : null;
    }
    /**
     * Set RevenueCenter value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RevenueCenter[] $revenueCenter
     * @return \ArrayType\ArrayOfRevenueCenter
     */
    public function setRevenueCenter(array $revenueCenter = array())
    {
        foreach ($revenueCenter as $arrayOfRevenueCenterRevenueCenterItem) {
            // validation for constraint: itemType
            if (!$arrayOfRevenueCenterRevenueCenterItem instanceof \StructType\RevenueCenter) {
                throw new \InvalidArgumentException(sprintf('The RevenueCenter property can only contain items of \StructType\RevenueCenter, "%s" given', is_object($arrayOfRevenueCenterRevenueCenterItem) ? get_class($arrayOfRevenueCenterRevenueCenterItem) : gettype($arrayOfRevenueCenterRevenueCenterItem)), __LINE__);
            }
        }
        if (is_null($revenueCenter) || (is_array($revenueCenter) && empty($revenueCenter))) {
            unset($this->RevenueCenter);
        } else {
            $this->RevenueCenter = $revenueCenter;
        }
        return $this;
    }
    /**
     * Add item to RevenueCenter value
     * @throws \InvalidArgumentException
     * @param \StructType\RevenueCenter $item
     * @return \ArrayType\ArrayOfRevenueCenter
     */
    public function addToRevenueCenter(\StructType\RevenueCenter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RevenueCenter) {
            throw new \InvalidArgumentException(sprintf('The RevenueCenter property can only contain items of \StructType\RevenueCenter, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RevenueCenter[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RevenueCenter|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RevenueCenter|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RevenueCenter|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RevenueCenter|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RevenueCenter|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RevenueCenter
     */
    public function getAttributeName()
    {
        return 'RevenueCenter';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRevenueCenter
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
