<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSurcharge ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSurcharge
 * @subpackage Arrays
 */
class ArrayOfSurcharge extends AbstractStructArrayBase
{
    /**
     * The Surcharge
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Surcharge[]
     */
    public $Surcharge;
    /**
     * Constructor method for ArrayOfSurcharge
     * @uses ArrayOfSurcharge::setSurcharge()
     * @param \StructType\Surcharge[] $surcharge
     */
    public function __construct(array $surcharge = array())
    {
        $this
            ->setSurcharge($surcharge);
    }
    /**
     * Get Surcharge value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Surcharge[]|null
     */
    public function getSurcharge()
    {
        return isset($this->Surcharge) ? $this->Surcharge : null;
    }
    /**
     * Set Surcharge value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Surcharge[] $surcharge
     * @return \ArrayType\ArrayOfSurcharge
     */
    public function setSurcharge(array $surcharge = array())
    {
        foreach ($surcharge as $arrayOfSurchargeSurchargeItem) {
            // validation for constraint: itemType
            if (!$arrayOfSurchargeSurchargeItem instanceof \StructType\Surcharge) {
                throw new \InvalidArgumentException(sprintf('The Surcharge property can only contain items of \StructType\Surcharge, "%s" given', is_object($arrayOfSurchargeSurchargeItem) ? get_class($arrayOfSurchargeSurchargeItem) : gettype($arrayOfSurchargeSurchargeItem)), __LINE__);
            }
        }
        if (is_null($surcharge) || (is_array($surcharge) && empty($surcharge))) {
            unset($this->Surcharge);
        } else {
            $this->Surcharge = $surcharge;
        }
        return $this;
    }
    /**
     * Add item to Surcharge value
     * @throws \InvalidArgumentException
     * @param \StructType\Surcharge $item
     * @return \ArrayType\ArrayOfSurcharge
     */
    public function addToSurcharge(\StructType\Surcharge $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Surcharge) {
            throw new \InvalidArgumentException(sprintf('The Surcharge property can only contain items of \StructType\Surcharge, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Surcharge[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Surcharge|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Surcharge|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Surcharge|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Surcharge|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Surcharge|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Surcharge
     */
    public function getAttributeName()
    {
        return 'Surcharge';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSurcharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
