<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoidReason ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVoidReason
 * @subpackage Arrays
 */
class ArrayOfVoidReason extends AbstractStructArrayBase
{
    /**
     * The VoidReason
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VoidReason[]
     */
    public $VoidReason;
    /**
     * Constructor method for ArrayOfVoidReason
     * @uses ArrayOfVoidReason::setVoidReason()
     * @param \StructType\VoidReason[] $voidReason
     */
    public function __construct(array $voidReason = array())
    {
        $this
            ->setVoidReason($voidReason);
    }
    /**
     * Get VoidReason value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VoidReason[]|null
     */
    public function getVoidReason()
    {
        return isset($this->VoidReason) ? $this->VoidReason : null;
    }
    /**
     * Set VoidReason value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VoidReason[] $voidReason
     * @return \ArrayType\ArrayOfVoidReason
     */
    public function setVoidReason(array $voidReason = array())
    {
        foreach ($voidReason as $arrayOfVoidReasonVoidReasonItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoidReasonVoidReasonItem instanceof \StructType\VoidReason) {
                throw new \InvalidArgumentException(sprintf('The VoidReason property can only contain items of \StructType\VoidReason, "%s" given', is_object($arrayOfVoidReasonVoidReasonItem) ? get_class($arrayOfVoidReasonVoidReasonItem) : gettype($arrayOfVoidReasonVoidReasonItem)), __LINE__);
            }
        }
        if (is_null($voidReason) || (is_array($voidReason) && empty($voidReason))) {
            unset($this->VoidReason);
        } else {
            $this->VoidReason = $voidReason;
        }
        return $this;
    }
    /**
     * Add item to VoidReason value
     * @throws \InvalidArgumentException
     * @param \StructType\VoidReason $item
     * @return \ArrayType\ArrayOfVoidReason
     */
    public function addToVoidReason(\StructType\VoidReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VoidReason) {
            throw new \InvalidArgumentException(sprintf('The VoidReason property can only contain items of \StructType\VoidReason, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VoidReason[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VoidReason|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VoidReason|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VoidReason|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VoidReason|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VoidReason|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoidReason
     */
    public function getAttributeName()
    {
        return 'VoidReason';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfVoidReason
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
