<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'ArrayOfBrandAllocation' => '\\ArrayType\\ArrayOfBrandAllocation',
            'BrandAllocation' => '\\StructType\\BrandAllocation',
            'DateRange' => '\\StructType\\DateRange',
            'ArrayOfCashDrawer' => '\\ArrayType\\ArrayOfCashDrawer',
            'CashDrawer' => '\\StructType\\CashDrawer',
            'ArrayOfDayPart' => '\\ArrayType\\ArrayOfDayPart',
            'DayPart' => '\\StructType\\DayPart',
            'ArrayOfDestination' => '\\ArrayType\\ArrayOfDestination',
            'Destination' => '\\StructType\\Destination',
            'ArrayOfDiscount' => '\\ArrayType\\ArrayOfDiscount',
            'Discount' => '\\StructType\\Discount',
            'ArrayOfEmployee' => '\\ArrayType\\ArrayOfEmployee',
            'Employee' => '\\StructType\\Employee',
            'EmployeeJobs' => '\\StructType\\EmployeeJobs',
            'EmployeeJob' => '\\StructType\\EmployeeJob',
            'ArrayOfItemGroup' => '\\ArrayType\\ArrayOfItemGroup',
            'ItemGroup' => '\\StructType\\ItemGroup',
            'SettingsObject' => '\\StructType\\SettingsObject',
            'ArrayOfItemGroupItem' => '\\ArrayType\\ArrayOfItemGroupItem',
            'ItemGroupItem' => '\\StructType\\ItemGroupItem',
            'ArrayOfItem' => '\\ArrayType\\ArrayOfItem',
            'Item' => '\\StructType\\Item',
            'ArrayOfItemCompositeComponent' => '\\ArrayType\\ArrayOfItemCompositeComponent',
            'ItemCompositeComponent' => '\\StructType\\ItemCompositeComponent',
            'ArrayOfItemCompositeComponentItem' => '\\ArrayType\\ArrayOfItemCompositeComponentItem',
            'ItemCompositeComponentItem' => '\\StructType\\ItemCompositeComponentItem',
            'ArrayOfItemIncludedModifier' => '\\ArrayType\\ArrayOfItemIncludedModifier',
            'ItemIncludedModifier' => '\\StructType\\ItemIncludedModifier',
            'ArrayOfJob' => '\\ArrayType\\ArrayOfJob',
            'Job' => '\\StructType\\Job',
            'ArrayOfLoyaltyReward' => '\\ArrayType\\ArrayOfLoyaltyReward',
            'LoyaltyReward' => '\\StructType\\LoyaltyReward',
            'DiscountReward' => '\\StructType\\DiscountReward',
            'GiftCardReward' => '\\StructType\\GiftCardReward',
            'PromotionReward' => '\\StructType\\PromotionReward',
            'VoucherReward' => '\\StructType\\VoucherReward',
            'ArrayOfModifierCode' => '\\ArrayType\\ArrayOfModifierCode',
            'ModifierCode' => '\\StructType\\ModifierCode',
            'ArrayOfModifierGroup' => '\\ArrayType\\ArrayOfModifierGroup',
            'ModifierGroup' => '\\StructType\\ModifierGroup',
            'ArrayOfModifierGroupItem' => '\\ArrayType\\ArrayOfModifierGroupItem',
            'ModifierGroupItem' => '\\StructType\\ModifierGroupItem',
            'Options' => '\\StructType\\Options',
            'AccountingOptions' => '\\StructType\\AccountingOptions',
            'GLExport' => '\\StructType\\GLExport',
            'ArrayOfGLExportDiscountAccount' => '\\ArrayType\\ArrayOfGLExportDiscountAccount',
            'GLExportDiscountAccount' => '\\StructType\\GLExportDiscountAccount',
            'GLExportAccount' => '\\StructType\\GLExportAccount',
            'ArrayOfGLExportOtherAccount' => '\\ArrayType\\ArrayOfGLExportOtherAccount',
            'GLExportOtherAccount' => '\\StructType\\GLExportOtherAccount',
            'ArrayOfGLExportPettyAccount' => '\\ArrayType\\ArrayOfGLExportPettyAccount',
            'GLExportPettyAccount' => '\\StructType\\GLExportPettyAccount',
            'ArrayOfGLExportPromotionAccount' => '\\ArrayType\\ArrayOfGLExportPromotionAccount',
            'GLExportPromotionAccount' => '\\StructType\\GLExportPromotionAccount',
            'ArrayOfGLExportRevenueCenterAccount' => '\\ArrayType\\ArrayOfGLExportRevenueCenterAccount',
            'GLExportRevenueCenterAccount' => '\\StructType\\GLExportRevenueCenterAccount',
            'ArrayOfGLExportSurchargeAccount' => '\\ArrayType\\ArrayOfGLExportSurchargeAccount',
            'GLExportSurchargeAccount' => '\\StructType\\GLExportSurchargeAccount',
            'ArrayOfGLExportTaxAccount' => '\\ArrayType\\ArrayOfGLExportTaxAccount',
            'GLExportTaxAccount' => '\\StructType\\GLExportTaxAccount',
            'ArrayOfGLExportTenderAccount' => '\\ArrayType\\ArrayOfGLExportTenderAccount',
            'GLExportTenderAccount' => '\\StructType\\GLExportTenderAccount',
            'LocationOptions' => '\\StructType\\LocationOptions',
            'ArrayOfPettyAccount' => '\\ArrayType\\ArrayOfPettyAccount',
            'PettyAccount' => '\\StructType\\PettyAccount',
            'ArrayOfPromotion' => '\\ArrayType\\ArrayOfPromotion',
            'Promotion' => '\\StructType\\Promotion',
            'ArrayOfRegister' => '\\ArrayType\\ArrayOfRegister',
            'Register' => '\\StructType\\Register',
            'ArrayOfRevenueCenter' => '\\ArrayType\\ArrayOfRevenueCenter',
            'RevenueCenter' => '\\StructType\\RevenueCenter',
            'ArrayOfSection' => '\\ArrayType\\ArrayOfSection',
            'Section' => '\\StructType\\Section',
            'ArrayOfSurcharge' => '\\ArrayType\\ArrayOfSurcharge',
            'Surcharge' => '\\StructType\\Surcharge',
            'ArrayOfTax' => '\\ArrayType\\ArrayOfTax',
            'Tax' => '\\StructType\\Tax',
            'ArrayOfTender' => '\\ArrayType\\ArrayOfTender',
            'Tender' => '\\StructType\\Tender',
            'ArrayOfVoidReason' => '\\ArrayType\\ArrayOfVoidReason',
            'VoidReason' => '\\StructType\\VoidReason',
            'GetCashDrawers' => '\\StructType\\GetCashDrawers',
            'GetCashDrawersResponse' => '\\StructType\\GetCashDrawersResponse',
            'GetDayParts' => '\\StructType\\GetDayParts',
            'GetDayPartsResponse' => '\\StructType\\GetDayPartsResponse',
            'GetDestinations' => '\\StructType\\GetDestinations',
            'GetDestinationsResponse' => '\\StructType\\GetDestinationsResponse',
            'GetDiscounts' => '\\StructType\\GetDiscounts',
            'GetDiscountsResponse' => '\\StructType\\GetDiscountsResponse',
            'GetEmployees' => '\\StructType\\GetEmployees',
            'GetEmployeesResponse' => '\\StructType\\GetEmployeesResponse',
            'GetItemGroups' => '\\StructType\\GetItemGroups',
            'GetItemGroupsResponse' => '\\StructType\\GetItemGroupsResponse',
            'GetItems' => '\\StructType\\GetItems',
            'GetItemsResponse' => '\\StructType\\GetItemsResponse',
            'GetJobs' => '\\StructType\\GetJobs',
            'GetJobsResponse' => '\\StructType\\GetJobsResponse',
            'GetLoyaltyRewards' => '\\StructType\\GetLoyaltyRewards',
            'GetLoyaltyRewardsResponse' => '\\StructType\\GetLoyaltyRewardsResponse',
            'GetModifierCodes' => '\\StructType\\GetModifierCodes',
            'GetModifierCodesResponse' => '\\StructType\\GetModifierCodesResponse',
            'GetModifierGroups' => '\\StructType\\GetModifierGroups',
            'GetModifierGroupsResponse' => '\\StructType\\GetModifierGroupsResponse',
            'GetOptions' => '\\StructType\\GetOptions',
            'GetOptionsResponse' => '\\StructType\\GetOptionsResponse',
            'GetPettyAccounts' => '\\StructType\\GetPettyAccounts',
            'GetPettyAccountsResponse' => '\\StructType\\GetPettyAccountsResponse',
            'GetPromotions' => '\\StructType\\GetPromotions',
            'GetPromotionsResponse' => '\\StructType\\GetPromotionsResponse',
            'GetRegisters' => '\\StructType\\GetRegisters',
            'GetRegistersResponse' => '\\StructType\\GetRegistersResponse',
            'GetRevenueCenters' => '\\StructType\\GetRevenueCenters',
            'GetRevenueCentersResponse' => '\\StructType\\GetRevenueCentersResponse',
            'GetSections' => '\\StructType\\GetSections',
            'GetSectionsResponse' => '\\StructType\\GetSectionsResponse',
            'GetSurcharges' => '\\StructType\\GetSurcharges',
            'GetSurchargesResponse' => '\\StructType\\GetSurchargesResponse',
            'GetTaxes' => '\\StructType\\GetTaxes',
            'GetTaxesResponse' => '\\StructType\\GetTaxesResponse',
            'GetTenders' => '\\StructType\\GetTenders',
            'GetTendersResponse' => '\\StructType\\GetTendersResponse',
            'GetVoidReasons' => '\\StructType\\GetVoidReasons',
            'GetVoidReasonsResponse' => '\\StructType\\GetVoidReasonsResponse',
            'AccessFault' => '\\StructType\\AccessFault',
            'LocationFault' => '\\StructType\\LocationFault',
        );
    }
}
