<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GLExport StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:GLExport
 * @subpackage Structs
 */
class GLExport extends AbstractStructBase
{
    /**
     * The Discounts
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportDiscountAccount
     */
    public $Discounts;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * The Others
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportOtherAccount
     */
    public $Others;
    /**
     * The PettyAccounts
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportPettyAccount
     */
    public $PettyAccounts;
    /**
     * The Promotions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportPromotionAccount
     */
    public $Promotions;
    /**
     * The RevenueCenters
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportRevenueCenterAccount
     */
    public $RevenueCenters;
    /**
     * The Surcharges
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportSurchargeAccount
     */
    public $Surcharges;
    /**
     * The Taxes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportTaxAccount
     */
    public $Taxes;
    /**
     * The Tenders
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportTenderAccount
     */
    public $Tenders;
    /**
     * The TendersForEcommerce
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfGLExportTenderAccount
     */
    public $TendersForEcommerce;
    /**
     * Constructor method for GLExport
     * @uses GLExport::setDiscounts()
     * @uses GLExport::setName()
     * @uses GLExport::setOthers()
     * @uses GLExport::setPettyAccounts()
     * @uses GLExport::setPromotions()
     * @uses GLExport::setRevenueCenters()
     * @uses GLExport::setSurcharges()
     * @uses GLExport::setTaxes()
     * @uses GLExport::setTenders()
     * @uses GLExport::setTendersForEcommerce()
     * @param \ArrayType\ArrayOfGLExportDiscountAccount $discounts
     * @param string $name
     * @param \ArrayType\ArrayOfGLExportOtherAccount $others
     * @param \ArrayType\ArrayOfGLExportPettyAccount $pettyAccounts
     * @param \ArrayType\ArrayOfGLExportPromotionAccount $promotions
     * @param \ArrayType\ArrayOfGLExportRevenueCenterAccount $revenueCenters
     * @param \ArrayType\ArrayOfGLExportSurchargeAccount $surcharges
     * @param \ArrayType\ArrayOfGLExportTaxAccount $taxes
     * @param \ArrayType\ArrayOfGLExportTenderAccount $tenders
     * @param \ArrayType\ArrayOfGLExportTenderAccount $tendersForEcommerce
     */
    public function __construct(\ArrayType\ArrayOfGLExportDiscountAccount $discounts = null, $name = null, \ArrayType\ArrayOfGLExportOtherAccount $others = null, \ArrayType\ArrayOfGLExportPettyAccount $pettyAccounts = null, \ArrayType\ArrayOfGLExportPromotionAccount $promotions = null, \ArrayType\ArrayOfGLExportRevenueCenterAccount $revenueCenters = null, \ArrayType\ArrayOfGLExportSurchargeAccount $surcharges = null, \ArrayType\ArrayOfGLExportTaxAccount $taxes = null, \ArrayType\ArrayOfGLExportTenderAccount $tenders = null, \ArrayType\ArrayOfGLExportTenderAccount $tendersForEcommerce = null)
    {
        $this
            ->setDiscounts($discounts)
            ->setName($name)
            ->setOthers($others)
            ->setPettyAccounts($pettyAccounts)
            ->setPromotions($promotions)
            ->setRevenueCenters($revenueCenters)
            ->setSurcharges($surcharges)
            ->setTaxes($taxes)
            ->setTenders($tenders)
            ->setTendersForEcommerce($tendersForEcommerce);
    }
    /**
     * Get Discounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportDiscountAccount|null
     */
    public function getDiscounts()
    {
        return isset($this->Discounts) ? $this->Discounts : null;
    }
    /**
     * Set Discounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportDiscountAccount $discounts
     * @return \StructType\GLExport
     */
    public function setDiscounts(\ArrayType\ArrayOfGLExportDiscountAccount $discounts = null)
    {
        if (is_null($discounts) || (is_array($discounts) && empty($discounts))) {
            unset($this->Discounts);
        } else {
            $this->Discounts = $discounts;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\GLExport
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Get Others value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportOtherAccount|null
     */
    public function getOthers()
    {
        return isset($this->Others) ? $this->Others : null;
    }
    /**
     * Set Others value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportOtherAccount $others
     * @return \StructType\GLExport
     */
    public function setOthers(\ArrayType\ArrayOfGLExportOtherAccount $others = null)
    {
        if (is_null($others) || (is_array($others) && empty($others))) {
            unset($this->Others);
        } else {
            $this->Others = $others;
        }
        return $this;
    }
    /**
     * Get PettyAccounts value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportPettyAccount|null
     */
    public function getPettyAccounts()
    {
        return isset($this->PettyAccounts) ? $this->PettyAccounts : null;
    }
    /**
     * Set PettyAccounts value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportPettyAccount $pettyAccounts
     * @return \StructType\GLExport
     */
    public function setPettyAccounts(\ArrayType\ArrayOfGLExportPettyAccount $pettyAccounts = null)
    {
        if (is_null($pettyAccounts) || (is_array($pettyAccounts) && empty($pettyAccounts))) {
            unset($this->PettyAccounts);
        } else {
            $this->PettyAccounts = $pettyAccounts;
        }
        return $this;
    }
    /**
     * Get Promotions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportPromotionAccount|null
     */
    public function getPromotions()
    {
        return isset($this->Promotions) ? $this->Promotions : null;
    }
    /**
     * Set Promotions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportPromotionAccount $promotions
     * @return \StructType\GLExport
     */
    public function setPromotions(\ArrayType\ArrayOfGLExportPromotionAccount $promotions = null)
    {
        if (is_null($promotions) || (is_array($promotions) && empty($promotions))) {
            unset($this->Promotions);
        } else {
            $this->Promotions = $promotions;
        }
        return $this;
    }
    /**
     * Get RevenueCenters value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportRevenueCenterAccount|null
     */
    public function getRevenueCenters()
    {
        return isset($this->RevenueCenters) ? $this->RevenueCenters : null;
    }
    /**
     * Set RevenueCenters value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportRevenueCenterAccount $revenueCenters
     * @return \StructType\GLExport
     */
    public function setRevenueCenters(\ArrayType\ArrayOfGLExportRevenueCenterAccount $revenueCenters = null)
    {
        if (is_null($revenueCenters) || (is_array($revenueCenters) && empty($revenueCenters))) {
            unset($this->RevenueCenters);
        } else {
            $this->RevenueCenters = $revenueCenters;
        }
        return $this;
    }
    /**
     * Get Surcharges value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportSurchargeAccount|null
     */
    public function getSurcharges()
    {
        return isset($this->Surcharges) ? $this->Surcharges : null;
    }
    /**
     * Set Surcharges value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportSurchargeAccount $surcharges
     * @return \StructType\GLExport
     */
    public function setSurcharges(\ArrayType\ArrayOfGLExportSurchargeAccount $surcharges = null)
    {
        if (is_null($surcharges) || (is_array($surcharges) && empty($surcharges))) {
            unset($this->Surcharges);
        } else {
            $this->Surcharges = $surcharges;
        }
        return $this;
    }
    /**
     * Get Taxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportTaxAccount|null
     */
    public function getTaxes()
    {
        return isset($this->Taxes) ? $this->Taxes : null;
    }
    /**
     * Set Taxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportTaxAccount $taxes
     * @return \StructType\GLExport
     */
    public function setTaxes(\ArrayType\ArrayOfGLExportTaxAccount $taxes = null)
    {
        if (is_null($taxes) || (is_array($taxes) && empty($taxes))) {
            unset($this->Taxes);
        } else {
            $this->Taxes = $taxes;
        }
        return $this;
    }
    /**
     * Get Tenders value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportTenderAccount|null
     */
    public function getTenders()
    {
        return isset($this->Tenders) ? $this->Tenders : null;
    }
    /**
     * Set Tenders value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportTenderAccount $tenders
     * @return \StructType\GLExport
     */
    public function setTenders(\ArrayType\ArrayOfGLExportTenderAccount $tenders = null)
    {
        if (is_null($tenders) || (is_array($tenders) && empty($tenders))) {
            unset($this->Tenders);
        } else {
            $this->Tenders = $tenders;
        }
        return $this;
    }
    /**
     * Get TendersForEcommerce value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfGLExportTenderAccount|null
     */
    public function getTendersForEcommerce()
    {
        return isset($this->TendersForEcommerce) ? $this->TendersForEcommerce : null;
    }
    /**
     * Set TendersForEcommerce value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfGLExportTenderAccount $tendersForEcommerce
     * @return \StructType\GLExport
     */
    public function setTendersForEcommerce(\ArrayType\ArrayOfGLExportTenderAccount $tendersForEcommerce = null)
    {
        if (is_null($tendersForEcommerce) || (is_array($tendersForEcommerce) && empty($tendersForEcommerce))) {
            unset($this->TendersForEcommerce);
        } else {
            $this->TendersForEcommerce = $tendersForEcommerce;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GLExport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
