<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GLExportAccount StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:GLExportAccount
 * @subpackage Structs
 */
class GLExportAccount extends AbstractStructBase
{
    /**
     * The Class
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Class;
    /**
     * The CreditAccount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CreditAccount;
    /**
     * The DebitAccount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DebitAccount;
    /**
     * The Memo
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Memo;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Name;
    /**
     * Constructor method for GLExportAccount
     * @uses GLExportAccount::setClass()
     * @uses GLExportAccount::setCreditAccount()
     * @uses GLExportAccount::setDebitAccount()
     * @uses GLExportAccount::setMemo()
     * @uses GLExportAccount::setName()
     * @param string $class
     * @param string $creditAccount
     * @param string $debitAccount
     * @param string $memo
     * @param string $name
     */
    public function __construct($class = null, $creditAccount = null, $debitAccount = null, $memo = null, $name = null)
    {
        $this
            ->setClass($class)
            ->setCreditAccount($creditAccount)
            ->setDebitAccount($debitAccount)
            ->setMemo($memo)
            ->setName($name);
    }
    /**
     * Get Class value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getClass()
    {
        return isset($this->Class) ? $this->Class : null;
    }
    /**
     * Set Class value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $class
     * @return \StructType\GLExportAccount
     */
    public function setClass($class = null)
    {
        // validation for constraint: string
        if (!is_null($class) && !is_string($class)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($class)), __LINE__);
        }
        if (is_null($class) || (is_array($class) && empty($class))) {
            unset($this->Class);
        } else {
            $this->Class = $class;
        }
        return $this;
    }
    /**
     * Get CreditAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCreditAccount()
    {
        return isset($this->CreditAccount) ? $this->CreditAccount : null;
    }
    /**
     * Set CreditAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $creditAccount
     * @return \StructType\GLExportAccount
     */
    public function setCreditAccount($creditAccount = null)
    {
        // validation for constraint: string
        if (!is_null($creditAccount) && !is_string($creditAccount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($creditAccount)), __LINE__);
        }
        if (is_null($creditAccount) || (is_array($creditAccount) && empty($creditAccount))) {
            unset($this->CreditAccount);
        } else {
            $this->CreditAccount = $creditAccount;
        }
        return $this;
    }
    /**
     * Get DebitAccount value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDebitAccount()
    {
        return isset($this->DebitAccount) ? $this->DebitAccount : null;
    }
    /**
     * Set DebitAccount value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $debitAccount
     * @return \StructType\GLExportAccount
     */
    public function setDebitAccount($debitAccount = null)
    {
        // validation for constraint: string
        if (!is_null($debitAccount) && !is_string($debitAccount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($debitAccount)), __LINE__);
        }
        if (is_null($debitAccount) || (is_array($debitAccount) && empty($debitAccount))) {
            unset($this->DebitAccount);
        } else {
            $this->DebitAccount = $debitAccount;
        }
        return $this;
    }
    /**
     * Get Memo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMemo()
    {
        return isset($this->Memo) ? $this->Memo : null;
    }
    /**
     * Set Memo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $memo
     * @return \StructType\GLExportAccount
     */
    public function setMemo($memo = null)
    {
        // validation for constraint: string
        if (!is_null($memo) && !is_string($memo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($memo)), __LINE__);
        }
        if (is_null($memo) || (is_array($memo) && empty($memo))) {
            unset($this->Memo);
        } else {
            $this->Memo = $memo;
        }
        return $this;
    }
    /**
     * Get Name value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getName()
    {
        return isset($this->Name) ? $this->Name : null;
    }
    /**
     * Set Name value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $name
     * @return \StructType\GLExportAccount
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        if (is_null($name) || (is_array($name) && empty($name))) {
            unset($this->Name);
        } else {
            $this->Name = $name;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GLExportAccount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
