<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetJobs StructType
 * @subpackage Structs
 */
class GetJobs extends AbstractStructBase
{
    /**
     * The accessToken
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $accessToken;
    /**
     * The locationToken
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $locationToken;
    /**
     * Constructor method for GetJobs
     * @uses GetJobs::setAccessToken()
     * @uses GetJobs::setLocationToken()
     * @param string $accessToken
     * @param string $locationToken
     */
    public function __construct($accessToken = null, $locationToken = null)
    {
        $this
            ->setAccessToken($accessToken)
            ->setLocationToken($locationToken);
    }
    /**
     * Get accessToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAccessToken()
    {
        return isset($this->accessToken) ? $this->accessToken : null;
    }
    /**
     * Set accessToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $accessToken
     * @return \StructType\GetJobs
     */
    public function setAccessToken($accessToken = null)
    {
        // validation for constraint: string
        if (!is_null($accessToken) && !is_string($accessToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($accessToken)), __LINE__);
        }
        if (is_null($accessToken) || (is_array($accessToken) && empty($accessToken))) {
            unset($this->accessToken);
        } else {
            $this->accessToken = $accessToken;
        }
        return $this;
    }
    /**
     * Get locationToken value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLocationToken()
    {
        return isset($this->locationToken) ? $this->locationToken : null;
    }
    /**
     * Set locationToken value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $locationToken
     * @return \StructType\GetJobs
     */
    public function setLocationToken($locationToken = null)
    {
        // validation for constraint: string
        if (!is_null($locationToken) && !is_string($locationToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($locationToken)), __LINE__);
        }
        if (is_null($locationToken) || (is_array($locationToken) && empty($locationToken))) {
            unset($this->locationToken);
        } else {
            $this->locationToken = $locationToken;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetJobs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
